"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var THREE = _interopRequireWildcard(require("three"));
var _computeBufferTileGeometry = _interopRequireWildcard(require("./Prefab/computeBufferTileGeometry"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function defaultBuffers(params) {
  params.buildIndexAndUv_0 = true;
  params.center = params.builder.center(params.extent).clone();
  const buffers = (0, _computeBufferTileGeometry.default)(params);
  buffers.index = new THREE.BufferAttribute(buffers.index, 1);
  buffers.uvs[0] = new THREE.BufferAttribute(buffers.uvs[0], 2);
  buffers.position = new THREE.BufferAttribute(buffers.position, 3);
  buffers.normal = new THREE.BufferAttribute(buffers.normal, 3);
  for (let i = 1; i < params.builder.uvCount; i++) {
    buffers.uvs[1] = new THREE.BufferAttribute(buffers.uvs[1], 1);
  }
  return buffers;
}
class TileGeometry extends THREE.BufferGeometry {
  constructor(params) {
    let buffers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultBuffers(params);
    super();
    this.center = params.center;
    this.extent = params.extent;
    this.segments = params.segments;
    this.setIndex(buffers.index);
    this.setAttribute('position', buffers.position);
    this.setAttribute('normal', buffers.normal);
    for (let i = 0; i < buffers.uvs.length; i++) {
      this.setAttribute(`uv_${i}`, buffers.uvs[i]);
    }
    this.computeBoundingBox();
    this.OBB = {};
    if (params.hideSkirt) {
      this.hideSkirt = params.hideSkirt;
    }
  }
  set hideSkirt(value) {
    this.setDrawRange(0, (0, _computeBufferTileGeometry.getBufferIndexSize)(this.segments, value));
  }
}
var _default = TileGeometry;
exports.default = _default;